<script setup lang="tsx">
import { reactive, ref, unref } from 'vue'
import {
  getSysLoginLogListApi,
  saveSysLoginLogApi,
  delSysLoginLogListApi,
  delSysLoginLogApi,
  querySysLoginLogApi,
  exportExcelApi,
  importExcelApiUrl
} from '@/api/system/SysLoginLog'
// import { Upload } from '@/components/Upload'
import { TableData } from '@/api/role/types'
import { useTable } from '@/hooks/web/useTable'
import { useI18n } from '@/hooks/web/useI18n'
import { Table, TableColumn } from '@/components/Table'
import { ElButton, ElLink, ElLoading, ElPopconfirm, ElMessage } from 'element-plus'
import { Search } from '@/components/Search'
import { FormSchema } from '@/components/Form'
import { ContentWrap } from '@/components/ContentWrap'
import Write from './components/Write.vue'
import Detail from './components/Detail.vue'
import { Dialog } from '@/components/Dialog'
import { getOrganTree } from '@/api/common'
import { getLoginOrganCodeByUserInfo } from '@/utils/auth';


defineOptions({
  name: 'SysLoginLog'
})

const { t } = useI18n()

const ids = ref<string[]>([])

const { tableRegister, tableState, tableMethods } = useTable({
  fetchDataApi: async () => {
    const { currentPage, pageSize } = tableState
    const res = await getSysLoginLogListApi({
      pageNum: unref(currentPage),
      pageSize: unref(pageSize),
      ...unref(searchParams)
    })
    return {
      list: res.body.list,
      total: res.body.total
    }
  },
  fetchDelApi: async () => {
    const res = await delSysLoginLogListApi(unref(ids))
    return !!res
  }
})

const { loading, dataList, total, currentPage, pageSize } = tableState
const { getList, getElTableExpose, delList, refresh } = tableMethods

const tableColumns = reactive<TableColumn[]>([
  {
    field: 'selection',
    type: 'selection'
  },
  {
    field: 'pkid',
    label: '会话id'
  },
  {
    field: 'userId',
    label: '登录号'
  },
  {
    field: 'userName',
    label: '用户姓名'
  },
  {
    field: 'organCode',
    label: '机构',
    hidden: true
  },
  {
    field: 'orgname',
    label: '机构名称'
  },
  {
    field: 'parentOrgan',
    label: '上级机构',
    hidden: true
  },
  {
    field: 'loginIp',
    label: '登录ip'
  },
  {
    field: 'loginTime',
    label: '登录时间'
  },
  {
    field: 'url',
    label: '登录URL',
    hidden: true
  },
  {
    field: 'logoutTime',
    label: '退出时间'
  }
])

// 获取当前用户机构号
const loginOrganCode = getLoginOrganCodeByUserInfo();
const searchSchema = reactive<FormSchema[]>([
  {
    field: 'userId',
    label: '登录号',
    component: 'Input'
  },
  {
    field: 'userName',
    label: '用户姓名',
    component: 'Input'
  },
  {
    field: 'organId',
    label: '机构',
    componentProps: { checkStrictly: true, nodeKey: 'id', props: { children: 'childs', label: 'nodeName' }, filterable: true },
    component: 'TreeSelect',
    optionApi: async () => {
      const res = await getOrganTree({
        treeid: '1',
        systemCode: 'portal',
        loginOrganCode
      });
      return res.body.result;
    },
  },
  {
    field: 'organName',
    label: '机构名称',
    component: 'Input',
    hidden:true
  },
  {
    field: 'loginIp',
    label: '登录ip',
    component: 'Input'
  },
  {
    field: 'loginTime',
    label: '登录时间',
    component: 'Input'
  },
  {
    field: 'logoutTime',
    label: '退出时间',
    component: 'Input'
  }
])

const searchParams = ref({})
const setSearchParams = (data: any) => {
  searchParams.value = data
  getList()
}

const dialogVisible = ref(false)
const dialogTitle = ref('')

const currentRow = ref()
const actionType = ref('')

const writeRef = ref<ComponentRef<typeof Write>>()

/**单行查询**/
const action = async (row: any, type: string) => {
  let detailLoading = ElLoading.service({
    background: 'rgba(0, 0, 0, 0.7)'
  })
  const res = await querySysLoginLogApi(row.pkid)
    .catch(() => {})
    .finally(() => {
      detailLoading.close()
    })
  detailLoading.close()
  if (res) {
    const data = res.body.result
    dialogTitle.value = t(type === 'edit' ? 'tableDemo.edit' : 'tableDemo.detail')
    actionType.value = type
    currentRow.value = data
    dialogVisible.value = true
  }
}

const AddAction = () => {
  dialogTitle.value = t('tableDemo.add')
  currentRow.value = undefined
  dialogVisible.value = true
  actionType.value = ''
}

const saveLoading = ref(false)

/** 保存 **/
const save = async () => {
  const write = unref(writeRef)
  const formData = await write?.submit()
  if (formData) {
    saveLoading.value = true
    const res = await saveSysLoginLogApi(formData)
      .catch(() => {})
      .finally(() => {
        saveLoading.value = false
      })
    if (res) {
      dialogVisible.value = false
      currentPage.value = 1
      getList()
    }
  }
}

const delLoading = ref(false)

/** 批量删除  **/
const delDataBatch = async () => {
  const elTableExpose = await getElTableExpose()
  ids.value = elTableExpose?.getSelectionRows().map((v: TableData) => v.pkid) || []
  delLoading.value = true
  await delList(unref(ids).length).finally(() => {
    delLoading.value = false
  })
}

/** 单行删除 */
const delData = async (row: TableData) => {
  const res = await delSysLoginLogApi(row.pkid)
  if (res) {
    const { code, errMsg } = res.head
    if (code === '0') {
      ElMessage.success('删除成功!')
      getList()
    } else {
      ElMessage.error(errMsg || '删除失败!')
    }
  }
}

const disabled = ref(true)

const onSelectionChange = (selection: TableData[]) => {
  disabled.value = selection.length === 0
}

/** 导出Excel */
const exportExcel = async () => {
  const data = { ...unref(searchParams),fileName:'登录日志' }
  await exportExcelApi(data)
}
</script>

<template>
  <ContentWrap>
    <Search :schema="searchSchema" @reset="setSearchParams" @search="setSearchParams" />

    <Table
      :columns="tableColumns"
      v-model:pageSize="pageSize"
      v-model:currentPage="currentPage"
      default-expand-all
      node-key="id"
      :data="dataList"
      :loading="loading"
      :pagination="{
        total
      }"
      @selection-change="onSelectionChange"
      @register="tableRegister"
      @refresh="refresh"
    >
      <template #buttons>
        <ElButton type="primary" @click="exportExcel()">导出</ElButton>
        <ElButton :loading="delLoading" type="primary" :disabled="disabled" @click="delDataBatch()">
          {{ t('tableDemo.del') }}
        </ElButton>
      </template>
    </Table>
  </ContentWrap>

  <Dialog v-model="dialogVisible" :title="dialogTitle">
    <Write v-if="actionType !== 'detail'" ref="writeRef" :current-row="currentRow" />
    <Detail v-if="actionType === 'detail'" :current-row="currentRow" />
    <template #footer>
      <ElButton v-if="actionType !== 'detail'" type="primary" :loading="saveLoading" @click="save">
        {{ t('dialogDemo.save') }}
      </ElButton>
      <ElButton @click="dialogVisible = false">{{ t('dialogDemo.close') }}</ElButton>
    </template>
  </Dialog>
</template>
